package org.jeecg.modules.regular.controller;

import java.util.Arrays;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.regular.entity.RegularTools;
import org.jeecg.modules.regular.service.IRegularToolsService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 检修工具
 * @Author: jeecg-boot
 * @Date:   2025-01-16
 * @Version: V1.0
 */
@Api(tags="检修工具")
@RestController
@RequestMapping("/regular/regularTools")
@Slf4j
public class RegularToolsController extends JeecgController<RegularTools, IRegularToolsService> {
	@Autowired
	private IRegularToolsService regularToolsService;

	@GetMapping("/workorder/{id}")
	public Result<?> queryToolsByWorkOrder(@PathVariable("id") String id){
		try{
			return Result.ok(regularToolsService.queryByWorkOrder(id));
		}catch (Exception e){
			return Result.error(e.getMessage());
		}
	}

	/**
	 * 分页列表查询
	 *
	 * @param regularTools
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "检修工具-分页列表查询")
	@ApiOperation(value="检修工具-分页列表查询", notes="检修工具-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<RegularTools>> queryPageList(RegularTools regularTools,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<RegularTools> queryWrapper = QueryGenerator.initQueryWrapper(regularTools, req.getParameterMap());
		Page<RegularTools> page = new Page<RegularTools>(pageNo, pageSize);
		IPage<RegularTools> pageList = regularToolsService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	 @ApiOperation(value="检修工具-列表查询全部", notes="检修工具-列表查询全部")
	 @GetMapping(value = "/list/all")
	 public Result<List<RegularTools>> queryAllList(RegularTools regularTools) {
		 List<RegularTools> pageList = regularToolsService.listAll(regularTools.getDetailId());
		 return Result.OK(pageList);
	 }

	/**
	 *   添加
	 *
	 * @param regularTools
	 * @return
	 */
	@AutoLog(value = "检修工具-添加")
	@ApiOperation(value="检修工具-添加", notes="检修工具-添加")
	//@RequiresPermissions("org.jeecg.modules:bu_regular_tools:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody RegularTools regularTools) {
		regularToolsService.save(regularTools);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param regularTools
	 * @return
	 */
	@AutoLog(value = "检修工具-编辑")
	@ApiOperation(value="检修工具-编辑", notes="检修工具-编辑")
	//@RequiresPermissions("org.jeecg.modules:bu_regular_tools:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody RegularTools regularTools) {
		regularToolsService.updateById(regularTools);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "检修工具-通过id删除")
	@ApiOperation(value="检修工具-通过id删除", notes="检修工具-通过id删除")
	//@RequiresPermissions("org.jeecg.modules:bu_regular_tools:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		regularToolsService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "检修工具-批量删除")
	@ApiOperation(value="检修工具-批量删除", notes="检修工具-批量删除")
	//@RequiresPermissions("org.jeecg.modules:bu_regular_tools:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.regularToolsService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "检修工具-通过id查询")
	@ApiOperation(value="检修工具-通过id查询", notes="检修工具-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<RegularTools> queryById(@RequestParam(name="id",required=true) String id) {
		RegularTools regularTools = regularToolsService.getById(id);
		if(regularTools==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(regularTools);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param regularTools
    */
    //@RequiresPermissions("org.jeecg.modules:bu_regular_tools:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, RegularTools regularTools) {
        return super.exportXls(request, regularTools, RegularTools.class, "检修工具");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_regular_tools:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, RegularTools.class);
    }

}
